/*
 * ConfigDialog.java
 *
 * Created on 2008/05/24, 6:33
 */
package pp4u;

import pp4u_manage.ManageConfigure;
import java.io.File;
import javax.swing.JFileChooser;

/**
 * 設定ダイアログ
 * @author tondol
 */
public class BoxConfigure extends javax.swing.JDialog {

    static private BoxConfigure instance = null;
    private JFileChooser chooser = null;

    private BoxConfigure(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    static public void showBox() {
        if (instance == null) {
            BoxMain parent = BoxMain.getInstance();
            instance = new BoxConfigure(parent, true);
        }
        instance.load();
        instance.setVisible(true);
    }

    private void load() {
        // 設定マネジャから取得
        ManageConfigure configure = ManageConfigure.getInstance();
        int port = configure.getPort();
        String dynamic = configure.getDynamic();
        File upload = configure.getUpload();
        File download = configure.getDownload();

        // フィールドに反映
        txtPort.setText(Integer.toString(port));
        if (dynamic != null) {
            txtDynamic.setText(dynamic);
        }
        if (upload != null) {
            txtUpload.setText(upload.getPath());
        }
        if (download != null) {
            txtDownload.setText(download.getPath());
        }
        btnApply.requestFocus();
    }

    private void save() {
        // フィールドから取得
        ManageConfigure configure = ManageConfigure.getInstance();
        int port = Integer.parseInt(txtPort.getText());
        String dynamic = txtDynamic.getText();
        File upload = new File(txtUpload.getText());
        File download = new File(txtDownload.getText());

        // 設定マネジャに反映
        configure.setPort(port);
        configure.setDynamic(dynamic);
        configure.setUpload(upload);
        configure.setDownload(download);
        btnApply.requestFocus();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        txtPort = new javax.swing.JTextField();
        txtDynamic = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        txtUpload = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        txtDownload = new javax.swing.JTextField();
        btnDowndir = new javax.swing.JButton();
        btnUpdir = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        btCancel = new javax.swing.JButton();
        btnApply = new javax.swing.JButton();

        setTitle("Pure P4U 設定");
        setResizable(false);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("ネットワーク設定"));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel3.setText("待受ポート");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        jPanel1.add(jLabel3, gridBagConstraints);

        txtPort.setFont(txtPort.getFont().deriveFont(txtPort.getFont().getSize()+2f));
        txtPort.setMinimumSize(new java.awt.Dimension(50, 27));
        txtPort.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        jPanel1.add(txtPort, gridBagConstraints);

        txtDynamic.setFont(txtDynamic.getFont().deriveFont(txtDynamic.getFont().getSize()+2f));
        txtDynamic.setMinimumSize(new java.awt.Dimension(50, 27));
        txtDynamic.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        jPanel1.add(txtDynamic, gridBagConstraints);

        jLabel6.setText("DDNS名");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        jPanel1.add(jLabel6, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(jPanel1, gridBagConstraints);

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("ネットワーク設定"));
        jPanel2.setLayout(new java.awt.GridBagLayout());

        jLabel4.setText("送信フォルダ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        jPanel2.add(jLabel4, gridBagConstraints);

        txtUpload.setFont(txtUpload.getFont().deriveFont(txtUpload.getFont().getSize()+2f));
        txtUpload.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        jPanel2.add(txtUpload, gridBagConstraints);

        jLabel5.setText("受信フォルダ");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        jPanel2.add(jLabel5, gridBagConstraints);

        txtDownload.setFont(txtDownload.getFont().deriveFont(txtDownload.getFont().getSize()+2f));
        txtDownload.setMinimumSize(new java.awt.Dimension(50, 27));
        txtDownload.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectTextAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        jPanel2.add(txtDownload, gridBagConstraints);

        btnDowndir.setFont(btnDowndir.getFont().deriveFont(btnDowndir.getFont().getSize()+1f));
        btnDowndir.setText("参照");
        btnDowndir.setActionCommand("送信参照");
        btnDowndir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSelect(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        jPanel2.add(btnDowndir, gridBagConstraints);

        btnUpdir.setFont(btnUpdir.getFont().deriveFont(btnUpdir.getFont().getSize()+1f));
        btnUpdir.setText("参照");
        btnUpdir.setActionCommand("受信参照");
        btnUpdir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSelect(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 5, 5);
        jPanel2.add(btnUpdir, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        getContentPane().add(jPanel2, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        btCancel.setMnemonic('C');
        btCancel.setText("キャンセル(C)");
        btCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonActions(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel3.add(btCancel, gridBagConstraints);

        btnApply.setMnemonic('A');
        btnApply.setText("適用(A)");
        btnApply.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonActions(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 5);
        jPanel3.add(btnApply, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 5, 5);
        getContentPane().add(jPanel3, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-358)/2, (screenSize.height-246)/2, 358, 246);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * ボタン押下時の処理
     */
    private void buttonActions(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonActions
        String action = evt.getActionCommand();
        if (action.equals("適用(A)")) {
            save();
        }
        dispose();
}//GEN-LAST:event_buttonActions

    /**
     * テキストボックスを選択する
     */
    private void selectTextAction(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_selectTextAction
        javax.swing.JTextField textBox = (javax.swing.JTextField) evt.getSource();
        textBox.selectAll();
    }//GEN-LAST:event_selectTextAction

    /**
     * 参照ダイアログの処理
     */
private void buttonSelect(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSelect
    // 設定ダイアログをインスタンス化
    if (chooser == null) {
        chooser = new JFileChooser();
        chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    }
    
    // 選択ディレクトリを取得
    int ret = chooser.showOpenDialog(this);
    File selected = chooser.getSelectedFile();
    String action = evt.getActionCommand();
    if (ret != JFileChooser.APPROVE_OPTION) {
        return;
    }
    
    // テキストフィールドに設定
    if (action.equals("送信参照")) {
        txtUpload.setText(selected.getPath());
    } else if (action.equals("受信参照")) {
        txtDownload.setText(selected.getPath());
    }
}//GEN-LAST:event_buttonSelect

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btCancel;
    private javax.swing.JButton btnApply;
    private javax.swing.JButton btnDowndir;
    private javax.swing.JButton btnUpdir;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JTextField txtDownload;
    private javax.swing.JTextField txtDynamic;
    private javax.swing.JTextField txtPort;
    private javax.swing.JTextField txtUpload;
    // End of variables declaration//GEN-END:variables
}
