/*
 * PP4UNodeBox.java
 *
 * Created on 2008/09/16, 21:56
 */
package pp4u;

import javax.swing.SwingWorker;
import pp4u_manage.ManageNodes;

/**
 * ノード追加ダイアログ
 * @author  tondol
 */
public class BoxNode extends javax.swing.JDialog {

    static private BoxNode instance = null;

    /** Creates new form PP4UNodeBox */
    public BoxNode(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    static public void showBox() {
        if (instance == null) {
            BoxMain parent = BoxMain.getInstance();
            instance = new BoxNode(parent, true);
        }
        instance.setVisible(true);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        taInput = new javax.swing.JTextArea();
        jPanel2 = new javax.swing.JPanel();
        btnAdd = new javax.swing.JButton();
        btnClose = new javax.swing.JButton();

        setTitle("Pure P4U ノード追加");
        setResizable(false);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("ノード追加"));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        taInput.setColumns(20);
        taInput.setFont(taInput.getFont());
        taInput.setRows(5);
        jScrollPane1.setViewportView(taInput);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel1.add(jScrollPane1, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        btnAdd.setMnemonic('A');
        btnAdd.setText("追加(A)");
        btnAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BoxNode.this.actionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        jPanel2.add(btnAdd, gridBagConstraints);

        btnClose.setMnemonic('C');
        btnClose.setText("閉じる(C)");
        btnClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BoxNode.this.actionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 5, 5);
        jPanel2.add(btnClose, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanel1.add(jPanel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.weighty = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(5, 5, 5, 5);
        getContentPane().add(jPanel1, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-347)/2, (screenSize.height-286)/2, 347, 286);
    }// </editor-fold>//GEN-END:initComponents

    /**
     * ボタン押下時の処理
     */
private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        final String action = evt.getActionCommand();
        SwingWorker worker = new SwingWorker() {
            @Override
            protected Object doInBackground() {
                if (action.equals("追加(A)")) {
                    String[] array = taInput.getText().split("\n");
                    for (String str : array) {
                        InfoNode node = new InfoNode(str);
                        ManageNodes.getInstance().add(node);
                    }
                    taInput.setText("");
                }
                return null;
            }
        };
        worker.execute();
        dispose();
}//GEN-LAST:event_actionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAdd;
    private javax.swing.JButton btnClose;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea taInput;
    // End of variables declaration//GEN-END:variables
    
}
