/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pp4u_manage;

import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;
import pp4u.AppMain;
import pp4u.TaskAbstract;

/**
 * タスク管理クラス
 * @author tondol
 */
public class ManageTasks extends AbstractTableModel implements Runnable {

    static ManageTasks instance = null;
    private ArrayList<TaskAbstract> tasks = null;
    private volatile Thread thread = null;

    private ManageTasks() {
        tasks = new ArrayList<TaskAbstract>();
    }

    static public ManageTasks getInstance() {
        if (instance == null) {
            instance = new ManageTasks();
        }
        return instance;
    }
    
    public void load() {
        if (thread == null) {
            thread = new Thread(this);
            thread.start();
        }
    }

    public void dispose() {
        if (thread == null) {
            return;
        } else {
            thread.interrupt();
        }
        
        TaskAbstract[] arrayTasks = null;
        synchronized (tasks) {
            arrayTasks = tasks.toArray(new TaskAbstract[0]);
        }
        for (TaskAbstract task : arrayTasks) {
            remove(task);
        }
    }
    
    public void run() {
        try {
            while (!thread.isInterrupted()) {
                TaskAbstract[] arrayTasks = null;
                synchronized (tasks) {
                    arrayTasks = tasks.toArray(new TaskAbstract[0]);
                }
                for (TaskAbstract task : arrayTasks) {
                    if (!task.isAlive()) {
                        remove(task);
                    }
                }
                fireTableDataChanged();
                Thread.sleep(1 * 1000);
            }
        } catch (Exception ex) {
        } finally {
            thread = null;
        }
    }
    
    public TaskAbstract getTask(int index) {
        return tasks.get(index);
    }

    public void add(TaskAbstract task) {
        synchronized (tasks) {
            if (tasks.contains(task)) {
                return;
            }
            tasks.add(task);
        }
        AppMain.debug("O タスク追加");
    }

    public void remove(TaskAbstract task) {
        synchronized (tasks) {
            tasks.remove(task);
        }
        AppMain.debug("X タスク削除");
    }
    
    //////////////////////////////////////////////
    // TableModelの実装もね
    //////////////////////////////////////////////
    @Override
    public int getColumnCount() {
        return 4;
    }

    @Override
    public String getColumnName(int column) {
        String ret = null;
        switch (column) {
            case 0:
                ret = "種別";
                break;
            case 1:
                ret = "ファイル名";
                break;
            case 2:
                ret = "接続先";
                break;
            case 3:
                ret = "ステータス";
                break;
        }
        return ret;
    }

    public int getRowCount() {
        return tasks.size();
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        Object obj = null;
        TaskAbstract task = null;
        synchronized (tasks) {
            task = tasks.get(rowIndex);
        }

        switch (columnIndex) {
            case 0:
                obj = task.getType();
                break;
            case 1:
                obj = task.getFilename();
                break;
            case 2:
                obj = task.getNode();
                break;
            case 3:
                obj = task.getStatus();
                break;
        }
        return obj;
    }
}
